Bug 471632 - Add support for SSL/RDMA URLs in cluster's know urls list
Add support for SSL/RDMA URLs in cluster's know urls list
Status: CLOSED ERRATA
Product: Red Hat Enterprise MRG
Classification: Red Hat
Component: qpid-cpp (Show other bugs)
1.0
All Linux
medium Severity medium
: 1.3
: ---
Assigned To: Alan Conway
Jan Sarenik
: FutureFeature
Depends On:
Blocks: 470080
  Show dependency treegraph
 
Reported: 2008-11-14 13:52 EST by Gordon Sim
Modified: 2010-10-14 12:11 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Both Secure Sockets Layer (SSL) and Remote Direct Memory Access (RDMA) entries can now appear in the list of known URLs.
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-10-14 12:11:15 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Gordon Sim 2008-11-14 13:52:20 EST
The broker will send the client a list of known urls (this is mainly useful in clustering where the list is also updated via broadcasts to a special exchange). Only TCP urls are supported at present.p
Comment 1 Alan Conway 2008-11-20 15:47:17 EST
See qpid/Address.h,.cpp. There are currently 2 address formats, "TcpAddress" and a dummy "ExampleAddress" that is there to test multi-protocol URL parsing and demonstrate how to add parsing for a new format. ExampleAddress should be removed as soon as there is a second real protocol format. 

The current code does *not* provide a link from Address types to the protocol keys of the protocol plugin, nor does it allow for protocols that were unknown at the time Url.cpp was compiled to be contributed by plugins. 

We *can* do this under the same API but we need to change the variant to a Blob and add some traits templates. 

For next release we have a fixed set of protocols. We need the link to the protocol keys so that we can open connections with URLs but we can live without unknown protocols contributed by plug-ins till the follow update.
Comment 3 Frantisek Reznicek 2010-02-10 05:47:31 EST
I was checking the Address.h header for indication what is the new url syntax for old and new API, the qpid::messaging::Address class changed, but I was not able to find the syntax.

Is there somewhere few words what is the current supported syntax?

putting NEEDINFO
Comment 5 Alan Conway 2010-05-10 08:50:40 EDT
See https://issues.apache.org/jira/browse/QPID-2591
Comment 6 Alan Conway 2010-05-13 14:57:36 EDT
Fixed in r943975, tested for SSL. Can't test with RDMA at the moment as the RDMA support is broken.
Comment 7 Jan Sarenik 2010-07-09 03:39:08 EDT
# qpidd --auth=no --no-module-dir --load-module /usr/lib64/qpid/daemon/rdma.so --load-module /usr/lib64/qpid/daemon/cluster.so --known-hosts-url amqp:rdma:192.168.55.26 --cluster-name=ahoj --cluster-url amqp:rdma:192.168.55.26

# qpid-stat -b
Brokers
  broker              cluster       uptime  conn  sess  exch  queue
  ===================================================================
  192.168.55.26:5672  ahoj(ACTIVE)  10s        1     1     8     5

# qpid-cluster
  Cluster Name: ahoj
Cluster Status: ACTIVE
  Cluster Size: 1
       Members: ID=192.168.55.26:20679 URL=amqp:rdma:192.168.55.26:5672
Comment 8 Jan Sarenik 2010-07-09 04:13:28 EDT
# qpidd --auth=no --no-module-dir --load-module /usr/lib64/qpid/daemon/rdma.so --load-module /usr/lib64/qpid/daemon/cluster.so --known-hosts-url amqp:rdma:192.168.55.26 --cluster-name=ahoj --cluster-url amqp:rdma:192.168.55.26
2010-07-09 04:12:33 notice Initializing CPG
2010-07-09 04:12:33 critical Unexpected error: Invalid URL: amqp:rdma:192.168.55.26 (qpid/Url.cpp:191)

# rpm -q qpid-cpp-server-cluster
qpid-cpp-server-cluster-0.7.935473-1.el5
Comment 9 Jan Sarenik 2010-07-09 04:14:53 EDT
Verified on qpid-cpp-server-cluster-0.7.946106-6.el5
Comment 10 Jaromir Hradilek 2010-10-07 09:51:22 EDT
    Technical note added. If any revisions are required, please edit the "Technical Notes" field
    accordingly. All revisions will be proofread by the Engineering Content Services team.
    
    New Contents:
Both Secure Sockets Layer (SSL) and Remote Direct Memory Access (RDMA) entries can now appear in the list of known URLs.
Comment 12 errata-xmlrpc 2010-10-14 12:11:15 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2010-0773.html

Note You need to log in before you can comment on or make changes to this bug.